#!/usr/local/bin/perl

###############################################################
# This script is programmed by ohhara@postech.ac.kr (9725018) #
#                                     1997/07/16 ~ 1997/07/22 #
###############################################################

# This is original structure of .DIR.
##define STRLEN 80
##define NAMELEN  40
#struct fileheader {             /* This structure is used to hold data in */
#	char filename[STRLEN];     /* the DIR files */
#	char owner[STRLEN];
#	char username[NAMELEN] ;/* user name (added by ryu)*/
#	char title[STRLEN];
#	unsigned int count;     /* A6H8<v */
#	unsigned level;
#	unsigned char accessed[ 12 ];   /* struct size = 256 bytes */
#};

$BBS_HOME="/home/bbs";
$BOARD_FILE=".DIR";

@months=("Jun","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

&ReadParse;

$bn=$in{'bn'};
$sn=$in{'sn'};
$dp=$in{'dp'};

open(bfile,"$BBS_HOME/boards/$bn/$BOARD_FILE");

for($total=0;!eof(bfile);$total++)
{
	seek(bfile,300,1);
}

if($sn eq "")
{
	$sn=$total;
}

if($dp eq "")
{
	$dp=20;
}

$nsn=$sn-$dp;
$bsn=$sn+$dp;

if($bsn>$total)
{
	$bsn=$total;
}

if($nsn<1)
{
	$nsn=0;
}

for($i=$sn;$i>$nsn;$i--)
{
	seek(bfile,300*($i-1),0);
	read(bfile,$filename[$i],20);
	seek(bfile,60,1);
	read(bfile,$owner[$i],15);
	seek(bfile,65,1);
	read(bfile,$username[$i],20);
	seek(bfile,20,1);
	read(bfile,$title[$i],50);
	seek(bfile,32,1);
	read(bfile,$temp1,1);
	$count[$i]=unpack("C",$temp1)*256;
	read(bfile,$temp2,1);
	$count[$i]+=unpack("C",$temp2);
	($M,$time_t,$A)=split(/\./,$filename[$i]);
	($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst)=localtime($time_t);
	if($mday<10)
	{
		$mday="0".$mday;
	}
	$time[$i]="$months[$mon] $mday";
}

close(bfile);


print "Content-type: text/html\n\n";
print "<html>";
print "<head>";
print "<title>$bn</title>";
print "</head>";
print "<body>";
print "$bn<p>";
print "<a href=\"read_boardlist.cgi\"> 尡 ֳ </a>";
print "<a href=\"read_board.cgi?bn=$bn&sn=$bsn&dp=$dp\">  </a>";
print "<a href=\"read_board.cgi?bn=$bn&sn=$nsn&dp=$dp\">  </a>";
print "<a href=\"write_boarddata.cgi?bn=$bn&sn=$sn&dp=$dp\">  </a>";
print "<br>";
print "<table>";
print "<tr><th>ȣ</th><th colspan=\"2\"></th><th>ȸ</th><th></th><th>...</th></tr>";

for($i=$sn;$i>$nsn;$i--)
{
	print "<tr><td>$i</td><td><a href=\"query.cgi?userid=$owner[$i]\">$owner[$i]</a></td><td><a href=\"query.cgi?userid=$owner[$i]\"> $username[$i]</a></td><td>$count[$i]</td><td>$time[$i]</td><td><a href=\"read_boarddata.cgi?bn=$bn&sn=$bsn&dp=$dp&fn=$filename[$i]\">$title[$i]</a></td>";
}

print "</table>";
print "<br>";
print "<a href=\"read_boardlist.cgi\"> 尡 ֳ </a>";
print "<a href=\"read_board.cgi?bn=$bn&sn=$bsn&dp=$dp\">  </a>";
print "<a href=\"read_board.cgi?bn=$bn&sn=$nsn&dp=$dp\">  </a>";
print "<a href=\"write_boarddata.cgi?bn=$bn&sn=$sn&dp=$dp\">  </a>";
print "<p>";
print "<a href=\"index.cgi\"> ޴</a> ";
print "<a href=\"http://www.postech.ac.kr\">Postech Ȩ</a>";
print "<hr>";
print "<address>";
print "Programmed by <a href=\"mailto:ohhara\@postech.ac.kr\">ohhara</a>";
print "</address>";
print "</body>";
print "</html>";

sub ReadParse {
  local (*in) = shift if @_;    # CGI input
  local (*incfn,                # Client's filename (may not be provided)
	 *inct,                 # Client's content-type (may not be provided)
	 *insfn) = @_;          # Server's filename (for spooled files)
  local ($len, $type, $meth, $errflag, $cmdflag, $perlwarn, $got);
	
  # Disable warnings as this code deliberately uses local and environment
  # variables which are preset to undef (i.e., not explicitly initialized)
  $perlwarn = $^W;
  $^W = 0;

  binmode(STDIN);   # we need these for DOS-based systems
  binmode(STDOUT);  # and they shouldn't hurt anything else 
  binmode(STDERR);
	
  # Get several useful env variables
  $type = $ENV{'CONTENT_TYPE'};
  $len  = $ENV{'CONTENT_LENGTH'};
  $meth = $ENV{'REQUEST_METHOD'};
  
  if ($len > $cgi_lib'maxdata) { #'
      &CgiDie("cgi-lib.pl: Request to receive too much data: $len bytes\n");
  }
  
  if (!defined $meth || $meth eq '' || $meth eq 'GET' || 
      $type eq 'application/x-www-form-urlencoded') {
    local ($key, $val, $i);
	
    # Read in text
    if (!defined $meth || $meth eq '') {
      $in = $ENV{'QUERY_STRING'};
      $cmdflag = 1;  # also use command-line options
    } elsif($meth eq 'GET' || $meth eq 'HEAD') {
      $in = $ENV{'QUERY_STRING'};
    } elsif ($meth eq 'POST') {
        if (($got = read(STDIN, $in, $len) != $len))
	  {$errflag="Short Read: wanted $len, got $got\n";};
    } else {
      &CgiDie("cgi-lib.pl: Unknown request method: $meth\n");
    }

    @in = split(/[&;]/,$in); 
    push(@in, @ARGV) if $cmdflag; # add command-line parameters

    foreach $i (0 .. $#in) {
      # Convert plus to space
      $in[$i] =~ s/\+/ /g;

      # Split into key and value.  
      ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

      # Convert %XX from hex numbers to alphanumeric
      $key =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
      $val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;

      # Associate key and value
      $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
    }

  } elsif ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
    # for efficiency, compile multipart code only if needed
$errflag = !(eval <<'END_MULTIPART');

    local ($buf, $boundary, $head, @heads, $cd, $ct, $fname, $ctype, $blen);
    local ($bpos, $lpos, $left, $amt, $fn, $ser);
    local ($bufsize, $maxbound, $writefiles) = 
      ($cgi_lib'bufsize, $cgi_lib'maxbound, $cgi_lib'writefiles);


    # The following lines exist solely to eliminate spurious warning messages
    $buf = ''; 

    ($boundary) = $type =~ /boundary="([^"]+)"/; #";   # find boundary
    ($boundary) = $type =~ /boundary=(\S+)/ unless $boundary;
    &CgiDie ("Boundary not provided: probably a bug in your server") 
      unless $boundary;
    $boundary =  "--" . $boundary;
    $blen = length ($boundary);

    if ($ENV{'REQUEST_METHOD'} ne 'POST') {
      &CgiDie("Invalid request method for  multipart/form-data: $meth\n");
    }

    if ($writefiles) {
      local($me);
      stat ($writefiles);
      $writefiles = "/tmp" unless  -d _ && -r _ && -w _;
      # ($me) = $0 =~ m#([^/]*)$#;
      $writefiles .= "/$cgi_lib'filepre"; 
    }

    $left = $len;
   PART: # find each part of the multi-part while reading data
    while (1) {
      die $@ if $errflag;

      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ?  $bufsize+$maxbound-length($buf): $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;

      $in{$name} .= "\0" if defined $in{$name}; 
      $in{$name} .= $fn if $fn;

      $name=~/([-\w]+)/;  # This allows $insfn{$name} to be untainted
      if (defined $1) {
        $insfn{$1} .= "\0" if defined $insfn{$1}; 
        $insfn{$1} .= $fn if $fn;
      }
 
     BODY: 
      while (($bpos = index($buf, $boundary)) == -1) {
        die $@ if $errflag;
        if ($name) {  # if no $name, then it's the prologue -- discard
          if ($fn) { print FILE substr($buf, 0, $bufsize); }
          else     { $in{$name} .= substr($buf, 0, $bufsize); }
        }
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, $maxbound)) != $amt);  
	die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      if (defined $name) {  # if no $name, then it's the prologue -- discard
        if ($fn) { print FILE substr($buf, 0, $bpos-2); }
        else     { $in {$name} .= substr($buf, 0, $bpos-2); } # kill last \r\n
      }
      close (FILE);
      last PART if substr($buf, $bpos + $blen, 4) eq "--\r\n";
      substr($buf, 0, $bpos+$blen+2) = '';
      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ? $bufsize+$maxbound-length($buf) : $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;


      undef $head;  undef $fn;
     HEAD:
      while (($lpos = index($buf, "\r\n\r\n")) == -1) { 
        die $@ if $errflag;
        $head .= substr($buf, 0, $bufsize);
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, $maxbound)) != $amt);  
        die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      $head .= substr($buf, 0, $lpos+2);
      push (@in, $head);
      @heads = split("\r\n", $head);
      ($cd) = grep (/^\s*Content-Disposition:/i, @heads);
      ($ct) = grep (/^\s*Content-Type:/i, @heads);

      ($name) = $cd =~ /\bname="([^"]+)"/i; #"; 
      ($name) = $cd =~ /\bname=([^\s:;]+)/i unless defined $name;  

      ($fname) = $cd =~ /\bfilename="([^"]*)"/i; #"; # filename can be null-str
      ($fname) = $cd =~ /\bfilename=([^\s:;]+)/i unless defined $fname;
      $incfn{$name} .= (defined $in{$name} ? "\0" : "") . 
        (defined $fname ? $fname : "");

      ($ctype) = $ct =~ /^\s*Content-type:\s*"([^"]+)"/i;  #";
      ($ctype) = $ct =~ /^\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;
      $inct{$name} .= (defined $in{$name} ? "\0" : "") . $ctype;

      if ($writefiles && defined $fname) {
        $ser++;
	$fn = $writefiles . ".$$.$ser";
	open (FILE, ">$fn") || &CgiDie("Couldn't open $fn\n");
        binmode (FILE);  # write files accurately
      }
      substr($buf, 0, $lpos+4) = '';
      undef $fname;
      undef $ctype;
    }

1;
END_MULTIPART
    if ($errflag) {
      local ($errmsg, $value);
      $errmsg = $@ || $errflag;
      foreach $value (values %insfn) {
        unlink(split("\0",$value));
      }
      &CgiDie($errmsg);
    } else {
      # everything's ok.
    }
  } else {
    &CgiDie("cgi-lib.pl: Unknown Content-type: $ENV{'CONTENT_TYPE'}\n");
  }

  # no-ops to avoid warnings
  $insfn = $insfn;
  $incfn = $incfn;
  $inct  = $inct;

  $^W = $perlwarn;

  return ($errflag ? undef :  scalar(@in)); 
}

