#!/usr/local/bin/perl

###############################################################
# This script is programmed by ohhara@postech.ac.kr (9725018) #
#                                     1997/07/25 ~ 1997/07/27 #
###############################################################

# This is original structure of .DIR.
##define STRLEN 80
##define BM_LEN 60
#struct shortfile {               /* used for caching files and boards */
#	char filename[STRLEN];      /* also will do for mail directories */
#	char owner[STRLEN - BM_LEN];
#	char BM[ BM_LEN ];
#	char title[STRLEN];
#	unsigned level;
#	unsigned char accessed;
#};

$BBS_HOME="/home/bbs";
$MAIL_FILE=".DIR";
$PASSWD_FILE=".PASSWDS";

$LOCK_SH = 1;
$LOCK_EX = 2;
$LOCK_NB = 4;
$LOCK_UN = 8;

@months=("Jun","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
@wdays=("Sun","Mon","Tue","Wed","Thu","Fri","Sat");

if($ENV{'REQUEST_METHOD'} eq "POST")
{
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else
{
	$buffer=$ENV{'QUERY_STRING'};
}
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
	($name, $value) = split(/=/, $pair);

	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	$FORM{$name} = $value;
}

$REMOTE_USER=$ENV{'REMOTE_USER'};
if($REMOTE_USER eq "guest")
{
	exit;
}
$userid=$FORM{'userid'};
&checkuserid($userid);
$username=&getusername($REMOTE_USER);
$title=$FORM{'title'};
$maildata=$FORM{'maildata'};

open(sgfile,"$BBS_HOME/home/$REMOTE_USER/signatures");
while(<sgfile>)
{
	$sig=$sig.$_;
}
close(sgfile);
$sig="--\n".$sig;

if($userid eq ""||$username eq ""||$title eq ""||$maildata eq "")
{
	print "Content-type: text/html\n\n";
	print "<html>";
	print "<head>";
	print "<title> </title>";
	print "</head>";
	print "<body>";
	print " <p>";
	print "<form method=\"POST\" action=\"write_maildata.cgi\" name=\"mail\">";
	print "To: <input type=\"text\" name=\"userid\" size=\"15\" value=\"$userid\"><br>";
	print "Title: <input type=\"text\" name=\"title\" size=\"50\" value=\"$title\"><br>";
	print "<textarea name=\"maildata\" rows=\"30\" cols=\"70\">";
	print "$sig";
	print "</textarea><br>";
	print "<input type=\"submit\" value=\"\">";
	print "<input type=\"reset\" value=\"ٽ \">";
	print "</form>";
	print "<p>";
	print "<a href=\"index.cgi\"> ޴</a> ";
	print "<a href=\"http://www.postech.ac.kr\">Postech Ȩ</a>";
	print "<hr>";
	print "<address>";
	print "Programmed by <a href=\"mailto:ohhara\@postech.ac.kr\">ohhara</a>";
	print "</address>";
	print "</body>";
	print "</html>";
	exit;
}

$filename="M.".time().".A";
($M,$time_t,$A)=split(/\./,$filename);
($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst)=localtime($time_t);
if($sec<10)
{
	$sec="0".$sec;
}
if($min<10)
{
	$min="0".$min;
}
if($hour<10)
{
	$hour="0".$hour;
}
if($mday<10)
{
	$mday=" ".$mday;
}
$time="$wdays[$wday] $months[$mon] $mday $hour:$min:$sec 19$year";
$maildata="From:      ".$username."\n"."Title:     ".$title."\n"."Date:      ".$time."\n\n".$maildata."\n\x00";

open(mfile,"+<$BBS_HOME/mail/$userid/$MAIL_FILE");
flock(mfile,$LOCK_EX);
for($total=0;!eof(mfile);$total++)
{
	seek(mfile,300,1);
}
seek(mfile,300*$total,0);
print mfile $filename;
seek(mfile,300*$total+80,0);
print mfile $username;
seek(mfile,300*$total+200,0);
print mfile $title;
seek(mfile,300*$total+299,0);
$null=pack("C","0");
print mfile $null;
flock(mfile,$LOCK_UN);
close(mfile);

use FileHandle;
sysopen(mdfile,"$BBS_HOME/mail/$userid/$filename",O_RDWR|O_CREAT|O_EXCL,0644);
print mdfile $maildata;
close(mdfile);

print "Content-type: text/html\n\n";
print "<html>";
print "<head>";
print "<title>";
print " ְ ޱ";
print "</title>";
print "</head>";
print "<body>";
print " ޵Ǿϴ.";
print "<p>";
print "<a href=\"index.cgi\"> ޴</a> ";
print "<a href=\"http://www.postech.ac.kr\">Postech Ȩ</a>";
print "<hr>";
print "<address>";
print "Programmed by <a href=\"mailto:ohhara\@postech.ac.kr\">ohhara</a>";
print "</address>";
print "</body>";
print "</html>";

sub checkuserid
{
	local($userid,$total);
	$userid=$_[0];
	open(pwfile,"$BBS_HOME/$PASSWD_FILE");
	for($total=0;!eof(pwfile);$total++)
	{
		read(pwfile,$temp,15);
		if($temp=~/^$userid\x00/)
		{
			last;
		}
		seek(pwfile,449,1);
	}
	if(eof(pwfile))
	{
		print "Content-type: text/html\n\n";
		print "<html>";
		print "<head>";
		print "<title>";
		print " ְ ޱ";
		print "</title>";
		print "</head>";
		print "<body>";
		print "$userid id   ã  ϴ";	
		print "<p>";
		print "<a href=\"index.cgi\"> ޴</a> ";
		print "<a href=\"http://www.postech.ac.kr\">Postech Ȩ</a>";
		print "<hr>";
		print "<address>";
		print "Programmed by <a href=\"mailto:ohhara\@postech.ac.kr\">ohhara</a>";
		print "</address>";
		print "</body>";
		print "</html>";
		exit;
	}
}

sub getusername
{
	local($userid,$username,$total);

	$userid=$_[0];

	open(pwfile,"$BBS_HOME/$PASSWD_FILE");

	for($total=0;!eof(pwfile);$total++)
	{
		read(pwfile,$temp,15);
		if($temp=~/^$userid\x00/)
		{
			last;
		}
		seek(pwfile,449,1);
	}
	seek(pwfile,73,1);
	read(pwfile,$username,20);
	$username=$userid." (".$username.")";
}

