#!/usr/local/bin/perl

###############################################################
# This script is programmed by ohhara@postech.ac.kr (9725018) #
#                                                  1997/07/28 #
###############################################################

# This is original structure of .DIR.
##define STRLEN 80
##define NAMELEN  40
#struct fileheader {             /* This structure is used to hold data in */
#	char filename[STRLEN];     /* the DIR files */
#	char owner[STRLEN];
#	char username[NAMELEN] ;/* user name (added by ryu)*/
#	char title[STRLEN];
#	unsigned int count;     /* A6H8<v */
#	unsigned level;
#	unsigned char accessed[ 12 ];   /* struct size = 256 bytes */
#};

$BBS_HOME="/home/bbs";
$BOARD_FILE=".DIR";
$PASSWD_FILE=".PASSWDS";

$LOCK_SH = 1;
$LOCK_EX = 2;
$LOCK_NB = 4;
$LOCK_UN = 8;

@months=("Jun","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
@wdays=("Sun","Mon","Tue","Wed","Thu","Fri","Sat");

if($ENV{'REQUEST_METHOD'} eq "POST")
{
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else
{
	$buffer=$ENV{'QUERY_STRING'};
}
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
	($name, $value) = split(/=/, $pair);

	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	$FORM{$name} = $value;
}

$REMOTE_USER=$ENV{'REMOTE_USER'};
if($REMOTE_USER eq "guest")
{
	exit;
}
$nickname=&getnickname($REMOTE_USER);
$username=$REMOTE_USER." ($nickname)";
$title=$FORM{'title'};
$bn=$FORM{'bn'};
$sn=$FORM{'sn'};
$dp=$FORM{'dp'};
$boarddata=$FORM{'boarddata'};


#$REMOTE_USER="ohhara";
#$nickname="϶";
#$username="ohhara (϶)";
#$title="̰ ׽ƮԴϴ.";
#$boarddata="  Ǿ\n Ǿ........";


open(sgfile,"$BBS_HOME/home/$REMOTE_USER/signatures");
while(<sgfile>)
{
	$sig=$sig.$_;
}
close(sgfile);
$sig="--\n".$sig;

if($username eq ""||$title eq ""||$boarddata eq "")
{
	print "Content-type: text/html\n\n";
	print "<html>";
	print "<head>";
	print "<title> </title>";
	print "</head>";
	print "<body>";
	print " <p>";
	print "<form method=\"post\" action=\"write_boarddata.cgi\">";
	print "Title: <input type=\"text\" name=\"title\" size=\"50\" value=\"$title\"><br>";
	print "<textarea name=\"boarddata\" rows=\"30\" cols=\"70\">";
	print "$sig";
	print "</textarea><br>";
	print "<input type=\"hidden\" name=\"bn\" value=\"$bn\">";
	print "<input type=\"hidden\" name=\"sn\" value=\"$sn\">";
	print "<input type=\"hidden\" name=\"dp\" value=\"$dp\">";
	print "<input type=\"submit\" value=\"\">";
	print "<input type=\"reset\" value=\"ٽ \">";
	print "</form>";
	print "<p>";
	print "<a href=\"index.cgi\"> ޴</a> ";
	print "<a href=\"http://www.postech.ac.kr\">Postech Ȩ</a>";
	print "<hr>";
	print "<address>";
	print "Programmed by <a href=\"mailto:ohhara\@postech.ac.kr\">ohhara</a>";
	print "</address>";
	print "</body>";
	print "</html>";
	exit;
}

$filename="M.".time().".A";
($M,$time_t,$A)=split(/\./,$filename);
($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst)=localtime($time_t);
if($sec<10)
{
	$sec="0".$sec;
}
if($min<10)
{
	$min="0".$min;
}
if($hour<10)
{
	$hour="0".$hour;
}
if($mday<10)
{
	$mday=" ".$mday;
}
$time="$wdays[$wday] $months[$mon] $mday $hour:$min:$sec 19$year";
$boarddata="Posted By: ".$username." on board \'$bn\'"."\n"."Title:     ".$title."\n"."Date:      ".$time."\n\n".$boarddata."\n\x00";

open(bfile,"+<$BBS_HOME/boards/$bn/$BOARD_FILE");
#open(bfile,"+<$BOARD_FILE");
flock(bfile,$LOCK_EX);
for($total=0;!eof(bfile);$total++)
{
	seek(bfile,300,1);
}
seek(bfile,300*$total,0);
print bfile $filename;
seek(bfile,300*$total+80,0);
print bfile $REMOTE_USER;
seek(bfile,300*$total+160,0);
print bfile $nickname;
seek(bfile,300*$total+200,0);
print bfile $title;
seek(bfile,300*$total+299,0);
$null=pack("C","0");
print bfile $null;
flock(bfile,$LOCK_UN);
close(bfile);

use FileHandle;
sysopen(bdfile,"$BBS_HOME/boards/$bn/$filename",O_RDWR|O_CREAT|O_EXCL,0644);
#sysopen(bdfile,"$filename",O_RDWR|O_CREAT|O_EXCL,0644);
print bdfile $boarddata;
close(bdfile);

print "Content-type: text/html\n\n";
print "<html>";
print "<head>";
print "<title>";
print " ";
print "</title>";
print "</head>";
print "<body>";
print " ϴ.";
print "<br>";
print "<a href=\"read_board.cgi?bn=$bn&sn=$sn&dp=$dp\"> ư</a>";
print "<a href=\"read_board.cgi?bn=$bn\"> ó ư</a>";
print "<p>";
print "<a href=\"index.cgi\"> ޴</a> ";
print "<a href=\"http://www.postech.ac.kr\">Postech Ȩ</a>";
print "<hr>";
print "<address>";
print "Programmed by <a href=\"mailto:ohhara\@postech.ac.kr\">ohhara</a>";
print "</address>";
print "</body>";
print "</html>";

sub getnickname
{
	local($userid,$nickname,$total);

	$userid=$_[0];

	open(pwfile,"$BBS_HOME/$PASSWD_FILE");

	for($total=0;!eof(pwfile);$total++)
	{
		read(pwfile,$temp,15);
		if($temp=~/^$userid\x00/)
		{
			last;
		}
		seek(pwfile,449,1);
	}
	seek(pwfile,73,1);
	read(pwfile,$nickname,20);
	$nickname;
}

